from odoo import models, fields, api, _
from odoo.exceptions import UserError


class MailChannel(models.Model):
    _inherit = "discuss.channel"
    _order = "is_open DESC, name"

    is_open = fields.Boolean("Is Open to Comments", default=True)


    def message_post(self, *args, **kwargs):
        if not all(self.mapped('is_open')):
            raise UserError(_("The mailing list is archived and can not be used anymore"))
        return super(MailChannel, self).message_post(*args, **kwargs)


    def toggle_archive_list(self):
        self.ensure_one()
        if self.env.user._is_system():
            if self.is_open:
                self.write({'is_open': False})
            else:
                self.write({'is_open': True})
        else:
            raise UserError(_("Only administrators can archive mailing lists"))
        return True
